\name{NW.fn}
\alias{NW.fn}
\title{Nadaraya-Watson Regression Estimation}
\description{
  This computes the Nadaraya-Watson local constant regression estimator
at the datapoints using a gaussian kernel.  For large datasets, it is not efficient.
}
\usage{
NW.fn(x, y, h)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{x}{numeric explanatory vector}
  \item{y}{numeric response vector}
  \item{h}{numeric bandwidth}
}
\value{
 a list of predictor values (x) and the corresponding predicted values (y)
}
\references{Wand and Jones, 1996, Kernel Smoothing, Chapman and Hall.}
\author{W.J. Braun}
\seealso{\code{\link{locpoly}}}

\examples{
x <- sort(runif(100))
y <- x + sin(x) + rnorm(100)*.1
plot(x,y)
lines(NW.fn(x,y,h=.1))
}
\keyword{models}
